*Hourly PM10-2.5 Concentrations:  Boxplots by year and season
 I:\aqtag\ezm\PMstaffpaper\code\convert_stp_ltp.sas
 Output: I:\aqtag\ezm\PMboxplotsseasons\output\pmcoarse_hrbxpts.cgm;

*next get nws met;
libname ws 'g:\user\share\billcox\mark\sasdat';
libname lib 'I:\aqtag\lqn\PMStaffPaper\data';
libname aqs oracle user=ezm pw=newaqs2 path='aqsprod';

*convert nws met to kelvin - mm hg and aggregate by day;
data lib.nws_met_data_hourly;
	 set ws.met;
	 if 2000 le year(sdate) le 2002;
	 temp=5/9*(t_fah-32)+273.15;
	 press=stnpr/1.33322;

*get closest met id to stp site;
proc sql; create table sites as select distinct SI_ID,
cc_cn_stt_state_code as st, cc_ci_city_code as city,
cc_cn_county_code as cou, site_latitude as lat,site_longitude as long,
site_id as id from aqs.sites; QUIT;
data sites (keep= si_id site lat long city); 
	 set sites;
	 if lat ne 0 and long ne 0;
	 long=-1*long;
	 site=st||cou||id; 
	 run;

proc sql; create table nwslatlon as select distinct id,lat as lat2, lon as long2 from lib.nws_met_data_hourly; quit;
proc sql; create table bothlatlon as select distinct id,site,lat,lat2,long,long2 from sites,nwslatlon; quit;
data cart;
	 set bothlatlon;
	 rp=6356.912;d=21.476; 
	 latR=lat*arcos(-1)/180;    
	 longR=long*arcos(-1)/180;  
	 latR2=lat2*arcos(-1)/180;    
	 longR2=long2*arcos(-1)/180;  

*Polar radius of earth with difference between polar & eq; 
 r=d*(cos(latR2)+cos(latR))*.5+rp;* average radius (km);       
 d=arcos(cos(latR2)*cos(longR2)*cos(latr)*cos(longR)+cos(latR2) 
 *sin(longR2)*cos(latR)*sin(longR)                              
 + sin(latR2)*sin(latR))*r;* distance in km; 
run; 
proc sort; by site D; run;
data lib.closest_metsite; set cart; by site D;
if first.site then do;
closeid=id;
dist=d*.62137;
drop id;
output;
end;
run;

/*
data misc;
merge lib.collocated_withmsaname (in=incol) lib.rdd88101d20002002129may03;
by site;
if incol;
run;
proc freq data=misc; by site; tables poc; run;
*/

*this code gives me site and one poc only;
data preppms;
set lib.rdd81102d20002002129may03;
by site poc;
if first.site;
run;
data preppms2;
merge preppms (in=inpreppms) lib.rdd81102d20002002129may03;
by site poc;
if inpreppms;
run;
proc freq data=preppms2; by site; tables poc; run;
proc sort data=preppms2; by site datetime; run;

*this code gives me site and one poc only;
data preppm25;
set lib.rdd88101d20002002129may03;
by site poc;
if first.site;
run;
data preppm25_2;
merge preppm25 (in=inpreppm25) lib.rdd88101d20002002129may03;
by site poc;
if inpreppm25;
run;
proc freq data=preppm25_2; by site; tables poc; run;
proc sort data=preppm25_2; by site datetime; run;

*this code gives me site and one poc only;
data preppml;
set lib.rdd85101d20002002111jul03;
by site poc;
if first.site;
run;
data preppml2;
merge preppml (in=inpreppml) lib.rdd85101d20002002111jul03;
by site poc;
if inpreppml;
run;
proc freq data=preppml2; by site; tables poc; run;
proc sort data=preppml2; by site datetime; run;

*this code combines pm10 LTP, pm10 STP, and PM2.5;
data lib.pml_pms_pm25;
merge preppml2 preppm25_2 preppms2;
by site datetime;
keep site datetime pm10l pm10s pm25l;
run;

*this code renames id to closeid;
data prepmet;
set lib.nws_met_data_hourly;
rename id=closeid;
run;
proc sort data=prepmet; by closeid; run;

*keeps only collocated sites;
data prepmet2;
merge lib.collocated_withmsaname (in=incol) lib.closest_metsite;
by site;
if incol;
run;
proc sort data=prepmet2; by closeid; run;

*this code keeps the collocated sites from the NWS Met data;
data prepmet3;
merge prepmet2 (in=inprepmet2) prepmet;
by closeid;
if inprepmet2;
DATETIME=dhms(sdate, hr, 0, 0);
format DATETIME datetime16.;
keep site msa msa_name closeid hr sdate DATETIME temp press;
run;

data prepall;
set lib.pml_pms_pm25;
sdate=datepart(datetime);
hr=hour(datetime);
run;

proc sort data=prepall; by site datetime; run;
proc sort data=prepmet3; by site datetime; run;

data lib.pml_pms_pm25_met;
merge prepmet3 (in=inprepmet3) prepall;
by site datetime;
if inprepmet3;
run;

data prepall2;
set lib.pml_pms_pm25_met;
if pm10l=. then do;
pm10l=pm10s*(298/temp)*(press/760);
end;
run;

data lib.final_pmcoarse;
set prepall2;
pmcoarse=pm10l-pm25l;
keep site msa msa_name hr sdate datetime pmcoarse;
run;
proc sort data=lib.final_pmcoarse; by site datetime; run;

data adjusttime;
set lib.final_pmcoarse;
if 	('02apr00:3:00:00'dt le datetime le '29oct00:00:00:00'dt) or
	('01apr01:3:00:00'dt le datetime le '28oct01:00:00:00'dt) or
	('07apr02:3:00:00'dt le datetime le '27oct02:00:00:00'dt)
	 then do; *if during DST, then add 1 hour;
		newdatetime=datetime+3600;
	 end;
	 else do;
	 	newdatetime=datetime;
	 end;
	 *get hour from newdatetime;
	 hour=hour(newdatetime);
	 *assign seasons;
	 if month(datepart(datetime)) in (12,1,2) then season='winter';
	 else if month(datepart(datetime)) in (3,4,5) then season='spring';
	 else if month(datepart(datetime)) in (6,7,8) then season='summer';
	 else if month(datepart(datetime)) in (9,10,11) then season='fall';
keep site msa msa_name newdatetime hour pmcoarse season;
run;

proc sort data=adjusttime; by msa_name hour; run;
*This code calculates the mean and finds the max pm25l. The maxid keeps
the season that is asociated with the max pm25l.  This code will produce
the data set for the annotate data set.  The annotate data set will label
the season from which the max comes from.;
proc means noprint data=adjusttime;
by msa_name hour;
var pmcoarse;
output out=maxseason mean=mean max=max maxid(pmcoarse(season))=maxseason;
run;


data prep4;
merge adjusttime (in=inadj) maxseason;
by msa_name hour;
if inadj;
if not first.hour then max=.;
if not first.hour then mean=.;
if not first.hour then season=.;
run;

data anno;
set maxseason;
length function $8.0;
function='label';
ysys='2';
xsys='2';
position='2';
x=hour;
y=max+1;
text=maxseason;
run;

filename gsasfile "I:\aqtag\ezm\PMboxplotsseasons\output\pmcoarse_hrbxpts.cgm";
goptions reset=all dev=cgmflwa gaccess=gsasfile ftext=HWCGM004 
		 ctext=black htext=1.0 cback=white colors=(black);
title1  h=1.5 "Hourly PM10-2.5 Concentrations, 2000-2002";
title2 ' ';
symbol1 i=boxt05 cv=blue;
symbol2 v=dot cv=blue;
symbol3 v=dot cv=blue;
axis1 order = (0 to 23 by 1)
      offset = (5,5)
	  minor = none
      label = none;
axis2 /*order =(0 to 700 by 100)*/
	  minor=none
      label=(angle=90 'Concentration, ug/m3');

proc gplot data=prep4;
	 format pmcoarse 3.;
	 by msa_name;
	 plot pmcoarse*hour max*hour mean*hour/
	 	overlay
		annotate=anno
		haxis=axis1
		vaxis=axis2;

run;
quit;



/*
proc sql; create table work.presstempnws as select distinct site,id,dist,zdate,temp as tempnws, press as pressnws
from sdata.closest a,sdata.ws b where a.closeid=b.id; quit;

data sdata.presstempall;
merge sdata.presstempaqs sdata.presstempnws; by site zdate;
run;
*/