*Hourly PM2.5 Concentrations:  Boxplots by year and season
 I:\aqtag\ezm\PMboxplotsseasons\code\hour_boxplots.sas
 Output: I:\aqtag\ezm\PMboxplotsseasons\output\hourlyboxplots.cgm;
 
libname lance 'I:\aqtag\ezm\PMboxplotsseasons\data'; run;
*just get sites with collocated hourly PM10 and PM2.5 data;
data getcol;
	 merge lance.collocated_withmsaname (in=incol) lance.rdd88101d20002002129may03;
	 by site;
	 if incol;
	 *get correct date and hour;
	 if ('02apr00:3:00:00'dt le datetime le '29oct00:00:00:00'dt) or
		('01apr01:3:00:00'dt le datetime le '28oct01:00:00:00'dt) or
		('07apr02:3:00:00'dt le datetime le '27oct02:00:00:00'dt)
	 then do; *if during DST, then add 1 hour;
		newdatetime=datetime+3600;
	 end;
	 else do;
	 	newdatetime=datetime;
	 end;
	 *get hour from newdatetime;
	 hour=hour(newdatetime);
	 *assign seasons;
	 if month(datepart(datetime)) in (12,1,2) then season='winter';
	 else if month(datepart(datetime)) in (3,4,5) then season='spring';
	 else if month(datepart(datetime)) in (6,7,8) then season='summer';
	 else if month(datepart(datetime)) in (9,10,11) then season='fall';
run;

*This code calculates the mean and finds the max pm25l. The maxid keeps
the season that is asociated with the max pm25l.  This code will produce
the data set for the annotate data set.  The annotate data set will label
the season from which the max comes from.;
proc means noprint data=getcol;
by msa_name hour;
var pm25l;
output out=maxseason mean=mean max=max maxid(pm25l(season))=maxseason;
run;
/*
proc univariate noprint data=getcol;
	 by msa_name hour;
	 var pm25l;
	 output out=dist n=nobs p5=p5 p95=p95 max=max min=min mean=mean;run;
proc print u; run;
*/

data prep4;
merge getcol (in=ingetcol) maxseason;
by msa_name hour;
if ingetcol;
if not first.hour then max=.;
if not first.hour then mean=.;
if not first.hour then season=.;
run;


data anno;
set maxseason;
length function $8.0;
function='label';
ysys='2';
xsys='2';
position='2';
x=hour;
y=max+1;
text=maxseason;
run;


filename gsasfile "I:\aqtag\ezm\PMboxplotsseasons\output\hourlyboxplots.cgm";
goptions reset=all dev=cgmflwa gaccess=gsasfile ftext=HWCGM004 
		 ctext=black htext=1.0 cback=white colors=(black);
title1  h=1.5 "Hourly PM2.5 Concentrations, 2000-2002";
title2 ' ';
symbol1 i=boxt05 cv=blue;
symbol2 v=dot cv=blue;
symbol3 v=dot cv=blue;
axis1 order = (0 to 23 by 1)
      offset = (5,5)
	  minor = none
      label = none;
axis2 /*order =(0 to 700 by 100)*/
	  minor=none
      label=(angle=90 'Concentration, ug/m3');

proc gplot data=prep4;
	 format pm25l 3.;
	 by msa_name;
	 plot pm25l*hour max*hour mean*hour/
	 	overlay
		annotate=anno
		haxis=axis1
		vaxis=axis2;

run;
quit;

/*
proc boxplot;
	 format pm25l 3.;
	 by msa_name;
	 id season;
	 plot pm25l*hour /
	 	boxstyle = schematicidfar
	    boxconnect=mean
	 	haxis=axis1
		vaxis=axis2;
run;quit;
*/


*plot hourly means by season for each msa;
/*
proc sort data=getcol;
	 by msa_name season hour;
proc univariate noprint;
	 by msa_name season hour;
	 var pm25l;
	 output out=next2 mean=season_mean n=n;
run;
proc sort data=next2; by msa_name hour;
proc transpose data=next2 out=tnext2;
	 by msa_name hour;
	 id season;
	 var season_mean;
run;

* graph them!;
filename gsasfile "I:\aqtag\ezm\PMboxplotsseasons\output\hourlymeans_byseason.cgm";
goptions reset=all dev=cgmflwa gaccess=gsasfile ftext=HWCGM004 
		 ctext=black htext=1.0 cback=white colors=(black);
title1  h=1.5 "Average Hourly PM2.5 Concentrations, 2000-2002";
title2 ' ';

symbol1 color=green interpol=join value=none w=2;
symbol2 color=red interpol=join value=none w=2;
symbol3 color=orange interpol=join value=none w=2;
symbol4 color=blue interpol=join value=none w=2;

axis1 order = (0 to 23 by 1)
      offset = (0,)
	  minor =none
      label = none;
axis2 order =(0 to 60 by 10)
	  minor=none
      label=(angle=90 'Concentration, ug/m3');

legend1 shape=line(6) position=(right top) offset=(-5,)
        mode=share across=1 label=none
		value=(j=l f="hwcgm004" 'Spring (Mar-May)' 'Summer (Jun-Aug)' 
				'Fall (Sep-Nov)' 'Winter(Dec-Feb)');

proc gplot data=tnext2;
	 by msa_name;
	 plot spring*hour summer*hour fall*hour winter*hour / 
			   overlay
			   skipmiss
			   legend=legend1
               haxis = axis1
               vaxis = axis2;
run;
quit;
*/





/*
data _null_;
dt1='05jun03:9:00:00'dt;
dt2='05jun03:10:00:00'dt;
dt3='05jun03:11:00:00'dt;
dt4='05jun03:12:00:00'dt;
dt5='05jun03:13:00:00'dt;

dt6='05jun03:23:00:00'dt;
dt7='06jun03:00:00:00'dt;
put dt1-dt7;
run;
*/