libname lib 'I:\lqn\PMStaffPaper\data';
*just get sites with collocated hourly PM10 and PM2.5 data;
data getcol;
	 set lib.final_pmcoarse;
	 *get correct date and hour;
	 if ('02apr00:3:00:00'dt le datetime le '29oct00:00:00:00'dt) or
		('01apr01:3:00:00'dt le datetime le '28oct01:00:00:00'dt) or
		('07apr02:3:00:00'dt le datetime le '27oct02:00:00:00'dt)
	 then do; *if during DST, then add 1 hour;
		newdatetime=datetime+3600;
	 end;
	 else do;
	 	newdatetime=datetime;
	 end;
	 *get hour from newdatetime;
	 hour=hour(newdatetime);
	 *assign seasons;
	 if month(datepart(datetime)) in (12,1,2) then season='winter';
	 else if month(datepart(datetime)) in (3,4,5) then season='spring';
	 else if month(datepart(datetime)) in (6,7,8) then season='summer';
	 else if month(datepart(datetime)) in (9,10,11) then season='fall';

*plot hourly means by season for each msa;

proc sort data=getcol;
	 by msa_name season hour;
proc univariate noprint;
	 by msa_name season hour;
	 var pmcoarse;
	 output out=next2 mean=season_mean n=n;
run;
proc sort data=next2; by msa_name hour;
proc transpose data=next2 out=tnext2;
	 by msa_name hour;
	 id season;
	 var season_mean;
run;

* graph them!;
filename gsasfile "I:\lqn\PMStaffPaper\output\hourlymeans_byseasonC&sysdate..cgm";
goptions reset=all dev=cgmflwa gaccess=gsasfile ftext=HWCGM004 
		 ctext=black htext=1.0 cback=white colors=(black);
title1  h=1.5 "Average Hourly PM10-2.5 Concentrations, 2000-2002";
title2 ' ';

symbol1 color=green interpol=join value=none w=2 l=1;
symbol2 color=red interpol=join value=none w=2 l=3;
symbol3 color=orange interpol=join value=none w=2 l=5;
symbol4 color=blue interpol=join value=none w=2 l=43;

axis1 order = (0 to 23 by 1)
      offset = (5,5)
	  minor =none
      label = none;
axis2 order =(0 to 110 by 10)
	  minor=(number=1)
	  label=(angle=90 'Concentration, ug/m3');

legend1 shape=line(6) position=(right top) offset=(-5,)
        mode=share across=1 label=none
		value=(j=l f="hwcgm004" 'Spring (Mar-May)' 'Summer (Jun-Aug)' 
				'Fall (Sep-Nov)' 'Winter(Dec-Feb)');

proc gplot data=tnext2;
	 by msa_name;
	 plot spring*hour summer*hour fall*hour winter*hour / 
			   overlay
			   skipmiss
			   legend=legend1
               haxis = axis1
               vaxis = axis2;
run;
quit;

/*
*plot hourly distribution for each msa, regardless of season;
proc sort data=getcol; by msa_name hour;

proc univariate noprint data=getcol;
	 by msa_name hour;
	 var pm25l;
	 output out=dist n=nobs p5=p5 p95=p95 max=max min=min mean=mean;run;
proc print u; run;
*/
/*
goptions reset=all dev=cgmflwa gaccess=gsasfile ftext=HWCGM004 
		 ctext=black htext=1.0 cback=white colors=(black);
title1  h=1.5 "Hourly PM2.5 Concentrations, 2000-2002";
title2 ' ';
*symbol i=boxjt05 cv=blue;
symbol v=dot;
axis1 order = (0 to 23 by 1)
      offset = (,8)
	  minor = none
      label = none;
axis2 order =(0 to 60 by 10)
	  minor=none
      label=(angle=90 'Concentration, ug/m3');
filename gsasfile "I:\aqtag\lqn\PMStaffPaper\output\hourlyboxplots.cgm";

proc boxplot;
	 format pm25l 3.;
	 by msa_name;
	 id season;
	 plot pm25l*hour /
	 	boxstyle = schematicidfar
	    boxconnect=mean
	 	haxis=axis1
		vaxis=axis2;
run;quit;
/*
proc gplot data=getcol;
	 format pm25l 3.;
	 by msa_name;
	 plot pm25l*hour /
	 	haxis=axis1
		vaxis=axis2;

run;
quit;
*/
/*
data _null_;
dt1='05jun03:9:00:00'dt;
dt2='05jun03:10:00:00'dt;
dt3='05jun03:11:00:00'dt;
dt4='05jun03:12:00:00'dt;
dt5='05jun03:13:00:00'dt;

dt6='05jun03:23:00:00'dt;
dt7='06jun03:00:00:00'dt;
put dt1-dt7;
run;
*/